# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# caret.R
# 20110425


library(caret)

## BloodBrain f[^Zbg
data(BloodBrain)
dim(bbbDescr)
head(names(bbbDescr))
head(logBBB)


## cars f[^Zbg
data(cars)
dim(cars)
names(cars)


## mdrr f[^Zbg
data(mdrr)
dim(mdrrDescr)
head(names(mdrrDescr))
head(rownames(mdrrDescr))
levels(mdrrClass)


## dhfr f[^Zbg
data(dhfr)
dim(dhfr)
head(names(dhfr))
levels(dhfr[,"Y"])


## oil f[^Zbg
data(oil)
dim(fattyAcids)
names(fattyAcids)
levels(oilType)


## PLS-DA
set.seed(1)
inTrain <- sample(seq(along = mdrrClass), 450)

nzv <- nearZeroVar(mdrrDescr)
filteredDescr <- mdrrDescr[, -nzv]

training <- filteredDescr[inTrain,]
test <- filteredDescr[-inTrain,]
trainMDRR <- mdrrClass[inTrain]
testMDRR <- mdrrClass[-inTrain]

preProcValues <- preProcess(training)
trainDescr <- predict(preProcValues, training)
testDescr <- predict(preProcValues, test)

useBayes <- plsda(trainDescr, trainMDRR, ncomp = 5,
                  probMethod = "Bayes")
useSoftmax <- plsda(trainDescr, trainMDRR, ncomp = 5)

table(predict(useBayes, testDescr), testMDRR)


## confusionMatrix ֐
confusionMatrix(predict(useSoftmax, testDescr), testMDRR)


## featurePlot ֐
trellis.par.set(theme = col.whitebg(), warn = FALSE)
featurePlot(iris[,-5], iris[,5], "ellipse")

featurePlot(iris[,-5], iris[,5], "box")
