# cj(ґ\)wRpbP[WKChubNx}
# http://www.tokyo-tosho.co.jp/books/ISBN978-4-489-02097-1.html
#
# Google http://www.google.com/search?q=ISBN978-4-489-02097-1
# Amazon http://www.amazon.co.jp/dp/448902097X
#
# IWî܂܂ł΃\[Xt@C̍Ĕzz͎RłB

# diseasemapping.R
# 20110425
library(diseasemapping)
library(sp)
data(popdata)
data(casedata)
class(popdata)
class(casedata)

model <- getRates(casedata, popdata, ~age * sex)

ontario <- getSMR(popdata, model, casedata)
ontario.d <- ontario@data[, c("CSDUID", "observed", "logExpected")]

library(spdep)
popDataAdjMat <- poly2nb(popdata, row.names = as.character(popdata[["CSDUID"]]))

print(popDataAdjMat)

library(glmmBUGS)
forBugs = glmmBUGS(formula = observed + logExpected ~ 1, effects = "CSDUID", family = "poisson",
                   spatial = popDataAdjMat, data = ontario.d)
startingValues <- forBugs$startingValues
source("getInits.R")

library(R2WinBUGS)
ontarioResult <- bugs(forBugs$ragged, getInits,
                      parameters.to.save = names(getInits()), model.file = "model.bug",
                      n.chain = 3, n.iter = 50, n.burnin = 10, n.thin = 2,
                      working.directory = getwd())

names(getInits())

ontarioParams <- restoreParams(ontarioResult, forBugs$ragged)
names(ontarioParams)

ontarioSummary <- summaryChain(ontarioParams)

res <- mergeBugsData(popdata, ontarioSummary, by.x = "CSDUID")

spplot(res, "FittedRateCSDUID.mean",
       col.regions = grey.colors(20, 0.9, 0.3))
